package com.qizhen.healsphere;

import java.util.regex.Pattern;

public class TextValidator {
    public static boolean isValidText(String text) {
        // 正则表达式解释：
        // ^ 表示字符串的开始
        // \\s* 表示0个或多个空白字符
        // (\\.\\s+)* 表示0个或多个点号（`.`）后跟1个或多个空白字符
        // [0-9]+ 表示1个或多个数字
        // (\\s+\\.\\s*)? 表示0个或1个点号（`.`）前后跟1个或多个空白字符
        // \\s* 表示0个或多个空白字符
        // $ 表示字符串的结束
        return Pattern.matches("^\\s*(\\.\\s+)*[0-9]+(\\s+\\.\\s*)?\\s*$", text);
    }

    public static void main(String[] args) {
        String input1 = ".      27";
        String input2 = "12       .   ";
        String input3 = "     27    ";
        String input4 = "27.";
        String input5 = ".27.";
        String input6 = "abc";
        String input7 = "27.45";
        String input8 = ".27 45.";
        String input9 = "27 45.";

        System.out.println(isValidText(input1)); // true
        System.out.println(isValidText(input2)); // true
        System.out.println(isValidText(input3)); // true
        System.out.println(isValidText(input4)); // false
        System.out.println(isValidText(input5)); // false
        System.out.println(isValidText(input6)); // false
        System.out.println(isValidText(input7)); // false
        System.out.println(isValidText(input8)); // true
        System.out.println(isValidText(input9)); // true
    }
}
