package com.qizhen.healsphere.common.ai;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.http.Method;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DeepSeekUtil {
    private static String apiUrl = "https://qianfan.baidubce.com/v2/chat/completions";

    public static String getChatResponse(String userInput) {
        int retry = 0;
        try {
            return getAnswer(userInput);
        }catch(Exception e){
            e.printStackTrace();
            retry++;
            if(retry>=2){
               return "";
            }
            return getAnswer(userInput);
        }

    }

    private static String getAnswer(String userInput) {
        // 构建请求体
        Map<String, Object> requestBody = new HashMap<>();

        //requestBody.put("model", "deepseek-v3");
        requestBody.put("model", "deepseek-r1");
        //requestBody.put("model", "ernie-3.5-8k");

        //app-VUPQ3Rq1
        Map messages = new HashMap();
        messages.put("role","user");
        messages.put("content",userInput);
        requestBody.put("messages", new Object[]{messages});
        String requestBodyJson = JSONObject.toJSONString(requestBody);
        System.out.println(requestBodyJson);
        HttpRequest request = HttpUtil.createRequest(Method.POST, apiUrl)
                .header("Content-Type", "application/json")
                .header("Authorization", "Bearer bce-v3/ALTAK-4724E5sCJcdxRCBCilJoL/641317ddac7137060721e65e688876f6c772115d")
                .body(requestBodyJson).timeout(60*1000);
        ;
        long l = System.currentTimeMillis();
        String resposne = request.execute().body();
        System.out.println("耗时:"+(System.currentTimeMillis()-l));
        System.out.println(resposne);
        String result = JSONObject.parseObject(resposne).getJSONArray("choices").getJSONObject(0).getJSONObject("message").getString("content");
        System.out.println(result);
        return result==null?"":result;
    }


    public static String fileName = "C:\\Users\\17664\\Desktop\\knowleges"+System.currentTimeMillis()+".xlsx";
    public static void main(String[] args) {
        // 获取access_token
/*        String zhiling = "\n" +
                "[  \n" +
                "    \"利巴韦林\",  \n" +
                "    \"奥司他韦\",  \n" +
                "    \"青霉素类\",  \n" +
                "    \"头孢菌素类\",  \n" +
                "    \"大环内酯类\"\n" +
                "]\n";*/
        String des = "“子宫内膜息肉”相关手术有哪些？";

        System.out.println(DeepSeekUtil.getChatResponse(des));
    }

    private static List<Knowlege> getData(String accessToken) {
        String diseaseStr = "湿疹； 痤疮； 足癣/脚气； 脱发； 银屑病/牛皮癣； 特应性皮炎/AD； 甲真菌病； 带状疱疹； 梅毒； 获得性免疫缺陷综合征； 白癜风； 毛囊炎； 扁平疣； 汗疱疹； 脂肪瘤； 甲沟炎； 过敏性紫癜； 生殖器疱疹； 脂溢性皮炎； 阴虱； 玫瑰糠疹； 花斑癣； 股癣； 淋球菌感染； 神经性皮炎； 珍珠状阴茎丘疹； 日光性皮炎； 肛门瘙痒症； 丘疹性荨麻疹； 臭汗症； 丹毒； 系统性红斑狼疮； 疥疮； 鹅口疮； 斑秃； 疖； 玫瑰痤疮； 急性荨麻疹； 黑色素瘤； 胆碱能性荨麻疹； 尖锐湿疣； 慢性荨麻疹； 接触性皮炎； 肋间神经痛； 麻疹； 黄褐斑； 毛囊角化病； 传染性软疣； 白化病； 黑棘皮病";
        String propertyStr = "诊疗操作" +
                ",治疗方案" +
                ",诊断标准" +
                ",治疗目标" +
                ",治疗方式" +
                ",治疗相关检查" +
                ",致病原因" +
                ",治疗原则" +
                ",诊疗依据" +
                ",治疗场所" +
                ",子类" +
                ",治疗器械" +
                ",治疗药物" +
                ",转出重症病房标准" +
                ",诊断相关检查" +
                ",症状" ;

        String[] diseases = diseaseStr.split("；");
        String[] properties = propertyStr.split(",");
        List<Knowlege> list = new ArrayList<>();
        for(String disease:diseases) {
            disease = disease.trim();
/*            String icd10Json = baidubceUtil.getChatResponse("你是一个医学专家，想知道"+disease+"对应的ICD-10疾病名称和编码是什么？请根据以下要求输出JSON数组格式的结果:\n" +
                    "不需要输出json之外的其他内容！\n" +
                    "- 键 \"name\"：疾病名称，字符串类型。\n" +
                    "- 键 \"code\"：对应的ICD10编码",accessToken);
            String icd10 = filte(icd10Json);*/
            for (String property : properties) {
                property = property.trim();
                String q = "你是一个医生。想知道"+disease+"有哪些"+property+"?";
                String answer = DeepSeekUtil.getChatResponse(q);
                String tiqu = "你是一个医学专业的关系抽取专家。需要从文本中提取"+disease+"的"+property+"，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：" +
                        "\n" +
                        "- 键 \"name\"：对应的"+property+"，字符串类型。\n" +
                        "- 键 \"description\"：对应的"+property+"的描述信息；如果没有，请使用空字符串。" +
                        "\n\n文本内容如下：\n\n" +answer;
                String chatResponse = DeepSeekUtil.getChatResponse(tiqu);
                chatResponse = filte(chatResponse);
                Knowlege knowlege = new Knowlege();
                knowlege.setEntity(disease);
                knowlege.setProperty(property);
                knowlege.setValue(chatResponse);
                knowlege.setAnswer(answer);
                //knowlege.setRefenrece(icd10);
                list.add(knowlege);
            }
        }
        return list;
    }

    private static String filte(String chatResponse) {
        if(chatResponse.startsWith("```json")){
            chatResponse = chatResponse.substring(7);
        }
        if(chatResponse.endsWith("```")){
            chatResponse = chatResponse.substring(0, chatResponse.length()-3);
        }
        return chatResponse;
    }


}
