package com.qizhen.healsphere.common.hyw.tongjihospital;

import com.qizhen.healsphere.common.pipeline.ExcelPipeline;
import org.jsoup.internal.StringUtil;
import us.codecraft.webmagic.Page;
import us.codecraft.webmagic.Site;
import us.codecraft.webmagic.Spider;
import us.codecraft.webmagic.processor.PageProcessor;

import java.util.Arrays;
import java.util.List;

/**
 * 华中科技大学同济医学院附属同济医院
 */
public class DepartmentPageProcessor implements PageProcessor {

        private Site site = Site.me().setRetryTimes(3).setSleepTime(1000).setTimeOut(10000);

        @Override
        public void process(Page page) {
            page.addTargetRequests(page.getHtml().links().regex("http://www\\.tjh\\.com\\.cn/channels/\\d+\\.html").all());
            String url = page.getUrl().toString();
            page.putField("id",url );
            page.putField("dept_name", page.getHtml().xpath("/html/body/div[4]/div[1]/div/h3/text()").toString());
            String des = page.getHtml().xpath("//div[@id='cstm_scroll1']/tidyText()").toString();
            page.putField("des",des);
            page.putField("rec_des", page.getHtml().xpath("//div[@id='cstm_scroll2']/tidyText()").toString());
            page.putField("dept_img", "https://www.tjh.com.cn/"+page.getHtml().xpath("/html/body/div[4]/div[2]/div/img/@src").toString());
            if (StringUtil.isBlank(des)){
                page.setSkip(true);
            }
        }

        @Override
        public Site getSite() {
            return site;
        }

        public static void main(String[] args) throws Exception {
            List<String> titles = Arrays.asList("id","dept_name","rec_des","des","dept_img");
            Spider.create(new DepartmentPageProcessor()).addUrl("http://www.tjh.com.cn/DeptNav/Index.html")
                    .addPipeline(new ExcelPipeline("C:\\Users\\17664\\Desktop\\hospitaldata","科室-华中科技大学同济医学院附属同济医院",titles)).thread(5).run();
        }
    }