package com.qizhen.healsphere.repository.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qizhen.healsphere.repository.mapper.entity.KgCountTotalInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

/**
 * <p>
 * 知识统计信息信息 Mapper 接口
 * </p>
 */
@Mapper
public interface KgCountTotalInfoMapper extends BaseMapper<KgCountTotalInfo> {
    
    @Select("SELECT id, gmt_create, gmt_modified, " +
            "node_type_num, node_num, node_prop_num, " +
            "relation_type_num, relation_num, term_num " +
            "FROM kg_count_total_info LIMIT 1")
    KgCountTotalInfo getCountTotalInfo();
    
    @Select("SELECT " +
            "1 as id, " +
            "now() as gmt_create, " +
            "now() as gmt_modified, " +
            "t1.node_type_num as node_type_num, " +
            "t1.node_num as node_num, " +
            "t2.node_prop_num as node_prop_num, " +
            "t3.relation_type_num as relation_type_num, " +
            "t3.relation_num as relation_num, " +
            "t4.term_num as term_num " +
            "FROM (" +
            "   SELECT COUNT(DISTINCT category) as node_type_num, COUNT(*) as node_num FROM kg_nodes" +
            ") t1, (" +
            "   SELECT COUNT(*) as node_prop_num FROM kg_props" +
            ") t2, (" +
            "   SELECT COUNT(DISTINCT name) as relation_type_num, COUNT(*) as relation_num FROM kg_edges" +
            ") t3, (" +
            "   SELECT COUNT(DISTINCT name) as term_num FROM kg_nodes" +
            ") t4")
    KgCountTotalInfo calculateTotalInfo();
}
