package com.qizhen.healsphere.service.impl;

import com.qizhen.healsphere.repository.neo4j.BaseNodeRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.HashMap;

@Service
@Slf4j
public class DepartmentServiceImpl {
    
    @Autowired
    private BaseNodeRepository baseNodeRepository;
    
    public Map<String, Object> getAllDepartmentDiseaseTrees() {
        try {
            List<Map<String, Object>> trees = baseNodeRepository.getAllDepartmentDiseaseTrees();
            Map<String, Object> result = new HashMap<>();
            result.put("name", "疾病");
            result.put("sNode", trees);
            return result;
        } catch (Exception e) {
            log.error("获取所有科室疾病树失败", e);
            throw new RuntimeException("获取所有科室疾病树失败", e);
        }
    }
} 