package com.qizhen.healsphere.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.qizhen.healsphere.repository.neo4j.BasePropertyRepository;
import com.qizhen.healsphere.repository.neo4j.param.UpdatePropertyParam;
import com.qizhen.healsphere.service.PropertyService;
import com.qizhen.healsphere.web.vo.DeletePropertyVO;
import com.qizhen.healsphere.web.vo.EntityVO;
import com.qizhen.healsphere.web.vo.UpdatePropertyVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class PropertyServiceImpl implements PropertyService {

    @Autowired
    BasePropertyRepository propertyRepository;


    @Override
    public List<Map<String, Object>> createEntityProperty(List<EntityVO> entityList) {

        List<Map<String, Object>> list = entityList.stream()
                .map(entityVO -> propertyRepository.createProperty(
                        entityVO.getLabel(),
                        entityVO.getNodeId(),
                        entityVO.getProperty()))
                .collect(Collectors.toList());
        return list;
    }


    @Override
    public List<Map<String, Object>> deleteEntityProperty(List<DeletePropertyVO> deletePropertyList) {

        List<Map<String, Object>> list = deletePropertyList.stream()
                .map(deletePropertyVO -> propertyRepository.deleteProperty(
                        deletePropertyVO.getLabel(),
                        deletePropertyVO.getNodeId(),
                        deletePropertyVO.getPropertyName()))
                .collect(Collectors.toList());

        return list;
    }

    @Override
    public Map<String, Object> updateEntityProperty(UpdatePropertyVO updateProperty) {

        UpdatePropertyParam updatePropertyParam = BeanUtil.copyProperties(updateProperty, UpdatePropertyParam.class);
        return propertyRepository.updateProperty(updatePropertyParam);
    }


}
