package com.qizhen.healsphere.web;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.qizhen.healsphere.service.impl.DepartmentServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@Controller
@RequestMapping("/api/department")
@Slf4j
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DepartmentController {
    
    @Autowired
    private DepartmentServiceImpl departmentService;
    
    @RequestMapping(value = "/disease-tree", method = RequestMethod.GET)
    @ResponseBody
    public Map<String, Object> getDepartmentDiseaseTree(@RequestParam(required = false) String departmentLabel) {
        return departmentService.getAllDepartmentDiseaseTrees();
    }
} 