package com.qizhen.healsphere.web;

import com.qizhen.healsphere.service.RelationshipService;
import com.qizhen.healsphere.web.dto.RespDTO;
import com.qizhen.healsphere.web.vo.RelationshipNameVO;
import com.qizhen.healsphere.web.vo.RelationshipVO;
import com.qizhen.healsphere.web.vo.UpdateRelationTypeVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@Controller
@RequestMapping("/relationship")
@Api(value = "关系API", tags = { "关系API" })
public class RelationshipController {

    @Autowired
    RelationshipService relationshipService;


    @ApiOperation(value = "批量新增关系(实体链接)",
            notes = "")
    @RequestMapping(value = "/createRelationship",method = RequestMethod.POST)
    @ResponseBody
    public RespDTO<Boolean> createRelationship(@RequestBody List<RelationshipVO> relationshipList) {

        Boolean flag = relationshipService.createRelationship(relationshipList);
        return RespDTO.onSuc(flag);
    }


    @ApiOperation(value = "批量删除关系",
            notes = "")
    @RequestMapping(value = "/deleteRelationship",method = RequestMethod.POST)
    @ResponseBody
    public RespDTO<Boolean> deleteRelationship(@RequestBody List<RelationshipVO> relationshipList) {

        Boolean flag = relationshipService.deleteRelationship(relationshipList);
        return RespDTO.onSuc(flag);
    }


    @ApiOperation(value = "根据名称模糊查询关系",
            notes = "")
    @RequestMapping(value = "/findRelationshipType",method = RequestMethod.POST)
    @ResponseBody
    public RespDTO<List<String>> findRelationshipType(@RequestBody RelationshipNameVO relationshipName) {

        List<String> relationshipTypeList = relationshipService.findRelationshipType(relationshipName);
        return RespDTO.onSuc(relationshipTypeList);
    }

    @ApiOperation(value = "批量更新实体名称",
            notes = "")
    @RequestMapping(value = "/updateRelationshipType",method = RequestMethod.POST)
    @ResponseBody
    public RespDTO<List<String>> updateRelationshipType(@RequestBody List<UpdateRelationTypeVO> updateRelationshipTypeList) {

        Boolean flag = relationshipService.updateRelationshipType(updateRelationshipTypeList);
        return RespDTO.onSuc(flag);
    }
}
