package com.qizhen.healsphere;

import cn.hutool.core.collection.CollectionUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.qizhen.healsphere.repository.mapper.KgEdgesMapper;
import com.qizhen.healsphere.repository.mapper.KgNodesMapper;
import com.qizhen.healsphere.repository.mapper.KgSchemasMapper;
import com.qizhen.healsphere.repository.mapper.entity.KgEdges;
import com.qizhen.healsphere.repository.mapper.entity.KgNodes;
import com.qizhen.healsphere.repository.mapper.entity.KgSchemas;
import com.qizhen.healsphere.repository.neo4j.BaseRelationshipRepository;
import com.qizhen.healsphere.repository.neo4j.entity.BaseEntity;
import com.qizhen.healsphere.repository.neo4j.entity.Edge;
import com.qizhen.healsphere.util.DataMigrationUtil;
import com.qizhen.healsphere.util.IcdRelationCreator;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.util.CollectionUtils;

import java.sql.Wrapper;
import java.util.HashMap;
import java.util.List;

@RunWith(SpringRunner.class)
@ComponentScan(basePackages = {"com.qizhen.healsphere"})
@SpringBootTest
public class DeletedDataTest {
    String version = "1.1";
    @Autowired
    BaseRelationshipRepository baseRelationshipRepository;

    @Autowired
    KgNodesMapper kgNodesMapper;

    @Autowired
    KgEdgesMapper kgEdgesMapper;

    @Autowired
    KgSchemasMapper kgSchemasMapper;

    @Autowired
    DataMigrationUtil dataMigrationUtil;

    @Autowired
    private IcdRelationCreator icdRelationCreator;

    @Test
    public void migrateData() {

        String relationships = "Vectors";
        String[] split = relationships.split(",");
        for(String relationship:split) {
            HashMap<String, Object> columnMap = new HashMap<>();
            columnMap.put("category", relationship);
            List<KgNodes> kgNodes = kgNodesMapper.selectByMap(columnMap);
            if(CollectionUtil.isEmpty(kgNodes)) {
                continue;
            }
            for(KgNodes temp:kgNodes) {
                columnMap = new HashMap<>();
                columnMap.put("src_id", temp.getId());
                System.out.println(kgEdgesMapper.deleteByMap(columnMap));
                columnMap = new HashMap<>();
                columnMap.put("dest_id", temp.getId());
                System.out.println(kgEdgesMapper.deleteByMap(columnMap));

                System.out.println(kgNodesMapper.deleteById(temp.getId()));
            }
        }
    }

    @Test
    public void mergeData() {

        HashMap<String, Object> columnMap = new HashMap<>();
        columnMap.put("category", "药品");
        List<KgNodes> kgNodes = kgNodesMapper.selectByMap(columnMap);
        for(KgNodes temp:kgNodes) {
            columnMap = new HashMap<>();
            columnMap.put("name", temp.getName());
            List<KgNodes> drugs = kgNodesMapper.selectByMap(columnMap);
            if(!CollectionUtils.isEmpty(drugs)){
                if(drugs.size()>1){
                    System.out.println(1111);
                }
                kgEdgesMapper.update1(temp.getId(), drugs.get(0).getId());
                kgEdgesMapper.update2(temp.getId(), drugs.get(0).getId());
            }else{
                temp.setCategory("Drug");
                kgNodesMapper.updateById(temp);
            }
        }
    }
}
