package com.qizhen.healsphere;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.qizhen.healsphere.repository.mapper.KgEdgesMapper;
import com.qizhen.healsphere.repository.mapper.KgNodesMapper;
import com.qizhen.healsphere.repository.mapper.KgSchemasMapper;
import com.qizhen.healsphere.repository.mapper.entity.KgEdges;
import com.qizhen.healsphere.repository.mapper.entity.KgNodes;
import com.qizhen.healsphere.repository.mapper.entity.KgSchemas;
import com.qizhen.healsphere.repository.neo4j.BaseNodeRepository;
import com.qizhen.healsphere.repository.neo4j.BaseRelationshipRepository;
import com.qizhen.healsphere.repository.neo4j.entity.BaseEntity;
import com.qizhen.healsphere.repository.neo4j.entity.Edge;
import com.qizhen.healsphere.service.EntityService;
import com.qizhen.healsphere.web.vo.MergeEntityVO;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RunWith(SpringRunner.class)
@ComponentScan(basePackages = {"com.qizhen.healsphere"})
@SpringBootTest
public class MergeDataTest {
    String version = "1.1";

    @Autowired
    KgNodesMapper kgNodesMapper;

    @Autowired
    KgEdgesMapper kgEdgesMapper;

    @Autowired
    KgSchemasMapper kgSchemasMapper;

    @Autowired
    EntityService entityService;

    @Autowired
    BaseNodeRepository baseNodeRepository;

    @Test
    public void mergeData() {
        String oldLabel = "分类";
        String newLabel = "疾病";
        List<BaseEntity> all = baseNodeRepository.getAll(oldLabel);
        for(BaseEntity temp:all){
            BaseEntity baseEntity = baseNodeRepository.byName(newLabel, temp.getName());
            if(baseEntity!=null){
                MergeEntityVO mergeEntity = new MergeEntityVO();
                mergeEntity.setFirstId(temp.getId());
                mergeEntity.setFirstLabel(oldLabel);
                mergeEntity.setSecondId(baseEntity.getId());
                mergeEntity.setSecondLabel(newLabel);
                mergeEntity.setNewName(baseEntity.getName());
                mergeEntity.setNewLabel(newLabel);
                entityService.mergeEntity(mergeEntity);
            }else{
                baseNodeRepository.renameLabel(newLabel, oldLabel, temp.getId());
            }
        }
    }

    @Test
    public void mergeData2() {
        String oldLabel = "鉴别诊断";
        String newLabel = "疾病";
        List<BaseEntity> all = baseNodeRepository.getAll(oldLabel);
        for(BaseEntity temp:all){
            BaseEntity baseEntity = baseNodeRepository.byName(newLabel, temp.getName());
            if(baseEntity!=null){
                MergeEntityVO mergeEntity = new MergeEntityVO();
                mergeEntity.setFirstId(temp.getId());
                mergeEntity.setFirstLabel(oldLabel);
                mergeEntity.setSecondId(baseEntity.getId());
                mergeEntity.setSecondLabel(newLabel);
                mergeEntity.setNewName(baseEntity.getName());
                mergeEntity.setNewLabel(newLabel);
                entityService.mergeEntity(mergeEntity);
            }else{
                baseNodeRepository.renameLabel(newLabel, oldLabel, temp.getId());
            }
        }
    }
}
